HackerRank color grid


https://github.com/shawnfan/LintCode/blob/master/Java/ColorGrid.java
https://www.hackerrank.com/contests/ioi-2014-practice-contest-1/challenges/color-grid-ioi14
You are given an N×NN×N grid. Each cell has the color white (color 0) in the beginning.
Each row and column has a certain color associated with it. Filling a row or column with a new color VV means changing all the cells of that row or column to VV (thus overriding the previous colors of the cells).
Now, given a sequence of PP such operations, calculate the sum of the colors in the final grid.
For simplicity, the colors will be positive integers whose values will be most 109109.
Input Format
The first line of input contains two integers NN and PP separated by a space.
The next PP lines each contain a filling operation. There are two types of filling operations.
ROW I V which means "fill row II with color VV".
COL I V which means "fill column II with color VV".
Output Format
Output one line containing exactly one integer which is the sum of the colors in the final grid.
Constraints
1≤N≤60001≤N≤6000
1≤P≤4000001≤P≤400000
1≤I≤N1≤I≤N
1≤V≤1091≤V≤109
Sample Input
5 4
COL 1 6
COL 4 11
ROW 3 9
COL 1 24
Sample Output
200
Explanation
There are four operations. After the second operation, the grid looks like
 6  0  0 11  0
 6  0  0 11  0
 6  0  0 11  0
 6  0  0 11  0
 6  0  0 11  0
After the third operation (ROW 3 9), the third row was colored with 9, overriding any previous color in the cells.
 6  0  0 11  0
 6  0  0 11  0
 9  9  9  9  9
 6  0  0 11  0
 6  0  0 11  0
After the fourth operation (COL 1 24), the grid becomes:
24  0  0 11  0
24  0  0 11  0
24  9  9  9  9
24  0  0 11  0
24  0  0 11  0
The sum of the colors in this grid is 200.

https://www.hackerrank.com/contests/ioi-2014-practice-contest-1/challenges/color-grid-ioi14/editorial
Note that simply simulating the  operations will take  time. This means that when  and , then this solution will take at least 2.4 billion operations. This is too slow to pass the time limit for this problem. 

Fast solution 1

Consider a particular row (or column). Suppose that there are two operations that write a color at that row (or column). Suppose that the first operation is done at time  and writes color , and the second operation is done at time  and operation  (where ).

Notice that the first operation is irrelevant, because you know that you will do another operation at that row (or column) at a later time, i.e. whatever you write at  will surely be overwritten at time . Therefore, simulating the first operation is not necessary.

What does this mean? This means that for every row/column, you should only simulate the latest operations that write to that row/column. This is done by first taking all operations, and taking note of the latest time of an operation per row and column, and finally simulating only the operations that are the last in their corresponding row/column.

Since there are  rows and  columns, there are at most  rows to simulate. Since each simulated operation costs  time, this algorithm takes  time (the  appears because we still have to read the operations). If  is less than 40 million, so this passes the time limit well :) 

Fast solution 2

There's an alternative  time solution. This involves reversing the order of operations, but instead of overriding the cells, we never write on the cells that have been written on already. Additionally, we also keep track whether a row/column has already been operated on already, because it is not really useful to simulate an operation on such a row/column. Thus, after simulating an operation, we mark that row or column as used ordeleted.

Since each row or column will be operated on at most once, this algorithm also takes  time.

Even faster solution!

The solutions above will pass the time limit well. However, a simple modification of the second fast solution results in an even faster solution that will enable us to calculate the answer even if  had a much higher bound :)

The idea is this: at any point during simulating the operations in reverse, you know exactly how many cells in each row and column are alive. This is because after every row operation, the number of 'alive' rows is reduced by 1, and the same is true after a column operation.

Therefore, for a particular painting with color , we know exactly how many times the color  will be painted on the grid! This saves us from actually simulating the painting at all. There's no need to create a grid, just keep track of the number of alive rows and columns after every operation!

Since there is no more simulation, this algorithm now runs in  time! This means that the algorithm will still pass the time limit even though the upper bound for  were, say, 
int alive_row[411111];
int alive_col[411111];
int ts[411111];
int is[411111];
int vs[411111];
char cmd[111];
int main() {
    // take the input
    int n, p, i, v;
    scanf("%d%d", &n, &p);
    for (int i = 1; i <= n; i++) {
        alive_row[i] = alive_col[i] = 1;
    }
    for (int k = 0; k < p; k++) {
        scanf("%s%d%d", cmd, &i, &v);
        ts[k] = *cmd == 'R';
        is[k] = i;
        vs[k] = v;
    }

    // here, 'rows' is the number of undeleted rows left
    //       'cols' is the number of undeleted columns left
    //       'sum' is the current sum
    ll rows = n, cols = n, sum = 0;
    for (int k = p - 1; k >= 0; k--) {
        int i = is[k], v = vs[k];
        if (ts[k]) { // this is a row update
            if (alive_row[i]) {
                alive_row[i] = 0;
                sum += cols * v;
                rows--;
            } 
        } else { // this is a column update
            if (alive_col[i]) {
                alive_col[i] = 0;
                sum += rows * v;
                cols--;
            }
        }
    }

    // print the sum
    printf("%lld\n", sum);
}

Even, even faster solution!

Finally, this algorithm can be done in  time, by using a data structure called a set. Keep track of two sets called deleted_rows and deleted_cols, and any time a row or column is operated on, insert it into the corresponding set.

If the implementation of the set data structure uses hashing, then inserting in a set and checking if a value is in a set should run in  time! For more information on hash-based sets, and sets in general, see Set (abstract data type).

Note that the complexity  is independent of . This means that our algorithm will still work even if 's bound was even higher, say, , where we won't even have enough memory to allocate  bytes! 
unordered_set<int> deleted_rows;
unordered_set<int> deleted_cols;
int ts[411111];
int is[411111];
int vs[411111];
char cmd[111];
int main() {
    // take the input
    ll n;
    int p, i, v;
    scanf("%lld%d", &n, &p);
    for (int k = 0; k < p; k++) {
        scanf("%s%d%d", cmd, &i, &v);
        ts[k] = *cmd == 'R';
        is[k] = i;
        vs[k] = v;
    }

    // here, 'rows' is the number of undeleted rows left
    //       'cols' is the number of undeleted columns left
    //       'sum' is the current sum
    ll rows = n, cols = n, sum = 0;
    for (int k = p - 1; k >= 0; k--) {
        int i = is[k], v = vs[k];
        if (ts[k]) { // this is a row update
            if (deleted_rows.find(i) == deleted_rows.end()) {
                deleted_rows.insert(i);
                sum += cols * v;
                rows--;
            }
        } else { // this is a column update
            if (deleted_cols.find(i) == deleted_cols.end()) {
                deleted_cols.insert(i);
                sum += rows * v;
                cols--;
            }
        }
    }

    // print the sum
    printf("%lld\n", sum);
}
用HashMap, 理解题目规律,因为重复的计算可以被覆盖,所以是个优化题。

消灭重合点:      
如果process当下col, 其实要减去过去所有加过的row的交接点。。。    
再分析,就是每次碰到row 取一个单点, sumRow += xxx。      
然后process当下col时候, sum += colValue * N - sumRow. 就等于把交叉所有row(曾经Process过的row)的点减去了。很方便。

最后read in 是O(P),  process也是O(P).

class Cell {
    int x;
    boolean isRow;
    long value;
    public Cell(String s) {
        String[] ss = s.split(" ");
        this.isRow = ss[0].charAt(0) == 'R';
        this.x = Integer.parseInt(ss[1]);
        this.value = Long.parseLong(ss[2]);
    }
}
public static void main(String[] args) {
    Solution sol = new Solution();
   
    Scanner in = new Scanner(System.in);
    String[] ss = in.nextLine().split(" ");
    int N = Integer.parseInt(ss[0]);
    int P = Integer.parseInt(ss[1]);
   
    //Storage
    HashMap<String, Cell> map = new HashMap<String, Cell>();
    ArrayList<Cell> list = new ArrayList<Cell>();
   
    while (P != 0) {//O(P)
        //create Cell
        String s = in.nextLine();
        Cell cell = sol.new Cell(s);
        //add into list
        list.add(cell);
        //Check if cell exist in map.
        //if exist in map, replace it with current cell, and remove old cell from list
        String key = s.substring(0, s.lastIndexOf(" "));
        if (!map.containsKey(key)) {
            map.put(key, cell);
        } else {
            Cell oldCell = map.get(key);
            map.put(key, cell);
            list.remove(oldCell);
        }
        P--;
    }
   
    //Process final results
    int sumCol = 0;
    int sumRow = 0;
    long sum = 0;
    for (int i = 0; i < list.size(); i++) {//O(P)
        Cell cell = list.get(i);
        sum += cell.value * N;
        if (cell.isRow) {
            sum -= sumCol;
            sumRow += cell.value;
        } else {
            sum -= sumRow;
            sumCol += cell.value;
        }
    }
   
    System.out.println(sum);
}


Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts